package dev.shadowsoffire.apotheosis.adventure.compat;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.adventure.compat.AdventureJEIPlugin;
import dev.shadowsoffire.apotheosis.adventure.compat.ApothSmithingCategory;
import dev.shadowsoffire.apotheosis.adventure.socket.AddSocketsRecipe;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import java.util.List;
import java.util.function.Function;
import mezz.jei.api.constants.VanillaTypes;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.ingredient.IRecipeSlotsView;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.recipe.RecipeIngredientRole;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Font;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.FormattedText;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.SmithingRecipe;

class AddSocketsExtension implements ApothSmithingCategory.Extension<AddSocketsRecipe> {
  private static final List<ItemStack> DUMMY_OUTPUTS;
  
  static {
    DUMMY_OUTPUTS = AdventureJEIPlugin.DUMMY_INPUTS.stream().map(ItemStack::m_41777_).map(s -> {
          SocketHelper.setSockets(s, 1);
          return (Function)s;
        }).toList();
  }
  
  public void setRecipe(IRecipeLayoutBuilder builder, AddSocketsRecipe recipe, IFocusGroup focuses) {
    builder.addSlot(RecipeIngredientRole.INPUT, 1, 1).addIngredients((IIngredientType)VanillaTypes.ITEM_STACK, AdventureJEIPlugin.DUMMY_INPUTS);
    builder.addSlot(RecipeIngredientRole.INPUT, 50, 1).addIngredients(recipe.getInput());
    builder.addSlot(RecipeIngredientRole.OUTPUT, 108, 1).addItemStacks(DUMMY_OUTPUTS);
  }
  
  public void draw(AddSocketsRecipe recipe, IRecipeSlotsView recipeSlotsView, GuiGraphics gfx, double mouseX, double mouseY) {
    MutableComponent mutableComponent = Component.m_237110_("text.apotheosis.socket_limit", new Object[] { Integer.valueOf(recipe.getMaxSockets()) });
    Font font = (Minecraft.m_91087_()).f_91062_;
    gfx.m_280614_(font, (Component)mutableComponent, 62 - font.m_92852_((FormattedText)mutableComponent) / 2, 23, 0, false);
  }
}
